function x=thomas(b,a,c,f)
% Eliminazione di Gauss per matrice tridiagonale con
% diag principale a, lowerdiag b e upperdiag c, rhs f

n=length(f);

y(1) = f(1);
alfa(1)= a(1);
% b [1..n-1] => b [2,..,n]
b = [0;b];
for i=2:n
    beta = b(i)/alfa(i-1);
    alfa(i)=a(i)-c(i-1)*beta;
    y(i)=f(i)-y(i-1)*beta;
end
% risoluzione all'indietro
x(n)=y(n)/alfa(n);
for i=n-1:-1:1
    x(i)=(y(i)-c(i)*x(i+1))/alfa(i);
end
